# lisp versions and release
%define cmucl_ver  2005.12
%define sbcl_ver   0.9.7
%define clisp_ver  1:2.36

%define cmucl_build 1
%define sbcl_build  1
%define clisp_build 1

# only if packaging cvs
%define cvsdate 2005.12.14
                                                                                
Summary:      Superior Lisp Interaction Mode for Emacs
Name:         slime
Version:      1.2.1
Release:      2.3.cvs
License:      GPL
Group:        Development/Languages
URL:          http://www.cliki.net/SLIME
Source0:      %{name}-%{?cvsdate:%{cvsdate}}%{!?cvsdate:%{version}}.tar.gz
Patch0:       slime-1.2.1-swank-loader.patch
Patch1:       slime-1.2.1-swank-build.patch
Patch2:       slime-1.2.1-doc-makefile.patch
Patch3:       slime-sbcl-sigio.patch
BuildRoot:    %{_tmppath}/%{name}-%{version}-root
Packager:     Fernando Lopez-Lezcano
Vendor: Planet CCRMA
Distribution: Planet CCRMA

%if "%{cmucl_build}" == "1"
BuildRequires: cmucl = %{cmucl_ver}
%endif
%if "%{sbcl_build}" == "1"
BuildRequires: sbcl = %{sbcl_ver}
%endif
%if "%{clisp_build}" == "1"
BuildRequires: clisp = %{clisp_ver}
%endif
BuildRequires: texinfo tetex tetex-latex tetex-dvips

%description
SLIME is the Superior Lisp Interaction Mode for Emacs. This is an
ILISP-like development environment intended for maximum integration
with CMUCL (also works with SBCL, OpenMCL and work is ongoing on
Lispworks and current CVS version of CLISP and CLISP 2.32 on Linux).

%package cmucl
Summary:   Slime binaries for CMUCL
Group:     Development/Languages
Requires:  cmucl = %{cmucl_ver}
Requires:  slime = %{version}-%{release}

%description cmucl
Slime binaries for CMUCL

%package sbcl
Summary:   Slime binaries for SBCL
Group:     Development/Languages
Requires:  sbcl = %{sbcl_ver}
Requires:  slime = %{version}-%{release}

%description sbcl
Slime binaries for SBCL

%package clisp
Summary:   Slime binaries for Clisp
Group:     Development/Languages
Requires:  clisp = %{clisp_ver}
Requires:  slime = %{version}-%{release}

%description clisp
Slime binaries for Clisp


%prep
%setup -q -n %{name}-%{?cvsdate:%{cvsdate}}%{!?cvsdate:%{version}}
%patch1 -p1
%patch2 -p1
# change default communication style in threaded sbcl to :sigio
%patch3 -p1

%build
%if "%{cmucl_build}" == "1"
/usr/bin/lisp <<EOF
(in-package :cl-user)
(load "swank-loader.lisp")
(quit)
EOF
%endif

%if "%{sbcl_build}" == "1"
/usr/bin/sbcl <<EOF
(in-package :cl-user)
(load "swank-loader.lisp")
(quit)
EOF
%endif

%if "%{clisp_build}" == "1"
/usr/bin/clisp <<EOF
(in-package :cl-user)
(load "swank-loader.lisp")
(in-package :cl-user)
(bye)
EOF
%endif

# create documentation
cd doc
%{__make}
%{__make} slime.pdf

%install
%{__rm} -rf %{buildroot}
%{__mkdir} -p %{buildroot}%{_datadir}

%{__mkdir} -p %{buildroot}%{_libdir}/slime
%{__mv} fasl %{buildroot}%{_libdir}/slime

cd %{buildroot}%{_datadir}
%{__tar} xzpf %{SOURCE0}
%{__mv} slime-%{?cvsdate:%{cvsdate}}%{!?cvsdate:%{version}} slime
cd slime
%{__patch} -p1 <%{PATCH0}

%clean
%{__rm} -rf %{buildroot}


%files
%defattr(-,root,root,-)
%doc HACKING NEWS PROBLEMS README
%doc doc/slime.ps doc/slime.pdf
%{_datadir}/slime

%if "%{cmucl_build}" == "1"
%files cmucl
%defattr(-,root,root,-)
%{_libdir}/slime/fasl/cmu*
%endif

%if "%{sbcl_build}" == "1"
%files sbcl
%defattr(-,root,root,-)
%{_libdir}/slime/fasl/sbcl*
%endif

%if "%{clisp_build}" == "1"
%files clisp
%defattr(-,root,root,-)
%{_libdir}/slime/fasl/clisp*
%endif

%changelog
* Sat Dec 17 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.2.1-2.3.cvs
- changed communication style of threaded sbcl to sigio, otherwise there
  are problems with the realtime scheduler in common music (kills lisp if
  run), sigio appears to work fine. 
* Wed Dec 14 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.2.1-2.2.cvs
- cvs snapshot dated 2005.12.14
  to download cvs:
  export CVSROOT=:pserver:anonymous@common-lisp.net:/project/slime/cvsroot
  cvs login
  (password=anonymous)
  cvs checkout slime
* Sat Dec 10 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.2.1-2.1.cvs
- rebuilt for sbcl 0.9.7 and cmucl 2005.12
* Sat Dec  3 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.2.1-2.0.cvs
- updated to cvs snapshot, 1.2.1 does not compile with sbcl 0.9.6
* Sat Nov 12 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.2.1-2
- rebuild for new sbcl/cmucl/clisp versions
* Tue Aug 16 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.2.1-1
- updated to 1.2.1, updated swank patches
- do not build for clisp on fc4
- replaced texi2pdf with dvipdfm (fc4 does not include texi2pdf
* Wed Dec 29 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- spec file cleanup
* Mon Nov  8 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- added documentation build
* Sun Nov  7 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.0-1
- initial build.
